import java.awt.*;
import java.io.*;
import EditFrame;


public class Editor extends java.applet.Applet {
  
  public static void main(String args[]) {
    EditFrame frame = new EditFrame();
    frame.show();
  }

}



class EditFrame extends Frame {

  Label intro, anzahlLab, wdhLab, bilderLab, fileLab;
  Button anzahlBtn, wdhBtn, bilderBtn, endBtn, fileBtn;
  AnzahlDiaFr anzahlDia;
  WdhDiaFr wdhDia;
  BilderDiaFr bilderDia;
  NameDiaFr nameDia;

  boolean repeat;
  int anzahl;
  String fileName;
  

  EditFrame() {
    super("Bildwechsler-Assistent");
    this.resize(520,300);

    setLayout(null);
    
    intro = new Label("Dieser Assistent hilft ihnen eine Steuerungsdatei fr das Bildwechsler Applet zu erstellen");
    intro.reshape(15, 40, 500, 15);

    fileBtn = new Button("Dateinamen bestimmen");
    fileBtn.reshape(31, 80, 200, 25);

    fileLab = new Label("Geben Sie der Steuerungsdatei einen Namen");
    fileLab.reshape(12, 115, 250, 15);

    anzahlBtn = new Button("Anzahl der Bilder festlegen");
    anzahlBtn.reshape(289, 80, 200, 25);
    anzahlBtn.disable();
                           
    anzahlLab = new Label("Bestimmen Sie dann die Anzahl der Bilder");
    anzahlLab.reshape(270, 115, 238, 15);
    anzahlLab.disable();

    wdhBtn = new Button("Wiederholung festlegen");
    wdhBtn.reshape(31, 160, 200, 25);
    wdhBtn.disable();
                                        
    wdhLab = new Label("Abfolge wiederholen/nur einmal abspielen");
    wdhLab.reshape(12, 195, 245, 15);
    wdhLab.disable();

    bilderBtn = new Button("Bilder einfgen");
    bilderBtn.reshape(289, 160, 200, 25);
    bilderBtn.disable();

    bilderLab = new Label("Whlen Sie die Bilder und deren Ausrichtung");
    bilderLab.reshape(267, 195, 245, 15);
    bilderLab.disable();

    endBtn = new Button("Abbrechen");
    endBtn.reshape(408, 263, 100, 25);

    add(intro);
    add(anzahlBtn);
    add(anzahlLab);
    add(wdhBtn);
    add(wdhLab);
    add(bilderBtn);
    add(bilderLab);
    add(fileBtn);
    add(fileLab);
    add(endBtn);
  }

  public boolean handleEvent(Event evt)  {
    if (evt.id == Event.WINDOW_DESTROY) {
      System.exit(0);
      return true;
    } 
    else if (evt.id == Event.ACTION_EVENT && evt.target == fileBtn) {
      getFName();
      return true;
    }
    else if (evt.id == Event.ACTION_EVENT && evt.target == endBtn) {
      System.exit(0);
      return true;
    }
    else if (evt.id == Event.ACTION_EVENT && evt.target == anzahlBtn) {
      getAnzahl(); 
      return true;
    }
    else if (evt.id == Event.ACTION_EVENT && evt.target == wdhBtn) {
      getWdh();
      return true;
    }
    else if (evt.id == Event.ACTION_EVENT && evt.target == bilderBtn) {
      getBilder();
      return true;
    }
    else return super.handleEvent(evt);
  }


  private void getFName() {
    if (nameDia == null) {
      nameDia = new NameDiaFr(this);
    }
    else nameDia.show();
  }


  private void getAnzahl() {
    if (anzahlDia == null) {
      anzahlDia = new AnzahlDiaFr(this);
    }
    else anzahlDia.show();     //Soll verhindern, dass anzahlDia mehrmals initalisiert wird
  } 
  

  private void getWdh() {
    if (wdhDia == null) {
      wdhDia = new WdhDiaFr(this);
    }
    else wdhDia.show();    // dito
  }

  
  private void getBilder() {
    if (bilderDia == null) {
      bilderDia = new BilderDiaFr(this);
    }
    else bilderDia.show();  //dito
  }  
}


class AnzahlDiaFr extends Dialog {
  EditFrame edFr;
  Button fertigBtn;
  Label lab;
  Scrollbar scroll;
  
  AnzahlDiaFr(EditFrame ed) {
    super(ed, "Anzahl festlegen", true);
    resize(200,200);
    edFr = ed;
    setLayout(null);
    fertigBtn = new Button("Fertig");
    fertigBtn.reshape(75, 160, 50, 25);
    lab = new Label("1");
    lab.reshape(12, 40, 30, 15);
    scroll = new Scrollbar(Scrollbar.HORIZONTAL, 1, 0, 1, 99);   
    scroll.reshape(40, 40, 60, 25); 
    add(lab);
    add(scroll);
    add(fertigBtn);
    this.show();
  }

  public boolean handleEvent(Event evt) {
   if (evt.id == Event.ACTION_EVENT && evt.target == fertigBtn) {
      edFr.anzahl = scroll.getValue();
      edFr.anzahlBtn.disable();
      edFr.anzahlLab.disable();
      edFr.wdhBtn.enable();
      edFr.wdhLab.enable();
      edFr.hide();
      edFr.show();
      this.hide();
      return true;
    }
    else if (evt.target == scroll) {
      lab.setText(String.valueOf(scroll.getValue()));
      return true;
    }
    else return false;
  } 
}


class WdhDiaFr extends Dialog {
  EditFrame edFr;
  Button fertigBtn;
  Checkbox wdhBox;

  WdhDiaFr(EditFrame ed) {
    super(ed, "Wiederholung festlegen", true);
    edFr = ed;
    resize(200,200);
    setLayout(null);
    wdhBox = new Checkbox("Bildfolge wiederholen");
    wdhBox.reshape(12, 40, 170, 20);
    fertigBtn = new Button("Fertig");
    fertigBtn.reshape(75, 160, 50, 25);
    add(wdhBox);
    add(fertigBtn);
    this.show();
  }

  public boolean handleEvent(Event evt) {
    if (evt.id == Event.ACTION_EVENT && evt.target == fertigBtn) {
      edFr.wdhBtn.disable();
      edFr.wdhLab.disable();
      edFr.bilderBtn.enable();
      edFr.bilderLab.enable();
      edFr.hide();
      edFr.show();
      this.hide();
      edFr.repeat = wdhBox.getState();
      return true;
    }
    else return false;
  } 
}


class BilderDiaFr extends Dialog {
  EditFrame edFr;
  Button nextBtn;

  Label urlLab, pauseLab, verticalLab, horiLab;
  TextField urlTxt, pauseTxt;
  CheckboxGroup horiCBG, verticalCBG;

  PrintStream s;

  int currZahl = 0; 
  
  BilderDiaFr(EditFrame ed) {
    super(ed, "Bilder bestimmen", true);
    edFr = ed;
   
    try {
      s = new PrintStream(new FileOutputStream(edFr.fileName));
      s.println(String.valueOf(edFr.anzahl));
      s.println(String.valueOf(edFr.repeat));
    }
    catch(IOException e) { System.out.println("Error" +e); }

    resize(387, 227);
    setLayout(null);

    urlLab = new Label("URL des Bildes:");
    urlLab.reshape(12, 40, 100, 15);

    pauseLab = new Label("Anzeigedauer:");
    pauseLab.reshape(12, 70, 100, 15);

    urlTxt = new TextField();
    urlTxt.reshape(118, 38, 150, 20);

    pauseTxt = new TextField();
    pauseTxt.reshape(118, 68, 150, 20);
    
    nextBtn = new Button("Nchstes");
    nextBtn.reshape(158, 190, 70, 25);
    if (edFr.anzahl == 1) nextBtn.setLabel("Fertig");
    
    verticalCBG = new CheckboxGroup();
    horiCBG = new CheckboxGroup();

    verticalLab = new Label("vertikale Ausrichtung:");
    verticalLab.reshape(12, 120, 150, 15);
    horiLab = new Label("horizontale Ausrichtung:");
    horiLab.reshape(12, 150, 150, 15);
    Checkbox top = new Checkbox("Oben", verticalCBG, false);
    top.reshape(165, 118, 70, 20);
    Checkbox v_center = new Checkbox("Mitte", verticalCBG, true);
    v_center.reshape(235, 118, 70, 20);
    Checkbox bottom = new Checkbox("Unten", verticalCBG, false);
    bottom.reshape(300, 118, 70, 20);
    Checkbox left = new Checkbox("Links", horiCBG, false);
    left.reshape(165, 148, 70,20);
    Checkbox center = new Checkbox("Mitte", horiCBG, true);
    center.reshape(235, 148, 70, 20);
    Checkbox right = new Checkbox("Rechts", horiCBG, false);
    right.reshape(300, 148, 70, 20);

    add(urlLab);
    add(urlTxt);
    add(pauseLab);
    add(pauseTxt);
    add(nextBtn);
    add(horiLab);
    add(verticalLab);
    add(top);
    add(v_center);
    add(bottom);
    add(left);
    add(center);
    add(right); 
    this.show();
  }

  public boolean handleEvent(Event evt) {
    if (evt.id == Event.ACTION_EVENT && evt.target == nextBtn) {
      nextElement();
      return true;
    }
    else return false;
  }

  void nextElement() {
    try {
      s.println(urlTxt.getText());
      s.println(pauseTxt.getText());
      if (horiCBG.getCurrent().getLabel().equals("Rechts")) s.println("RIGHT");
      else if (horiCBG.getCurrent().getLabel().equals("Mitte")) s.println("CENTER");
      else if (horiCBG.getCurrent().getLabel().equals("Links")) s.println("LEFT");
      if (verticalCBG.getCurrent().getLabel().equals("Oben")) s.println("TOP");
      else if (verticalCBG.getCurrent().getLabel().equals("Mitte")) s.println("CENTER");
      else if (verticalCBG.getCurrent().getLabel().equals("Unten")) s.println("BOTTOM");
      urlTxt.setText("");
      pauseTxt.setText("");
      this.currZahl+=1;
      if (currZahl >= edFr.anzahl -1) nextBtn.setLabel("Fertig");
      if (currZahl >= edFr.anzahl) {
        this.hide();
        System.out.println();
        System.out.println("Steuerungsdatei "+edFr.fileName+" erfolgreich erstellt !");
        System.out.println();
        System.out.println("Bildwechsler Assistent (c) 1997 by Markus Westphal  (MarkusWestphal@T-Online.de) ");
        System.exit(0);
      }
    }
    catch(Exception e) { System.out.println("Error" +e); }
  } 
}


class NameDiaFr extends Dialog {

  TextField fileTxt;
  Label fileLab;
  Button fertigBtn;
  EditFrame edFr;
  
  NameDiaFr(EditFrame ed) {
    super(ed, "Dateinamen", true); 
    edFr = ed;
    resize(218, 200);
    setLayout(null);
    fileLab = new Label("Bitte geben sie den Dateinamen an:");
    fileLab.reshape(12, 40, 200, 15);
    fileTxt = new TextField();
    fileTxt.reshape(12, 70, 150, 20);
    fertigBtn = new Button("Fertig");
    fertigBtn.reshape(84, 163, 50, 25);
    add(fileLab);
    add(fileTxt);
    add(fertigBtn);
    show();
  }


  public boolean handleEvent(Event e) {
    if (e.id == Event.ACTION_EVENT && e.target == fertigBtn) {
      edFr.fileBtn.disable();
      edFr.fileLab.disable();
      edFr.anzahlBtn.enable();
      edFr.anzahlLab.enable();
      edFr.hide();
      edFr.show();
      this.hide();
      edFr.fileName = fileTxt.getText();
      return true;
    }
    else return false;
  }

  
}



